var M=1,K=60,T=3600,B=86400,O=604800,y=class i{constructor(t,e=1){this.rate=t;this.size=e;if(t<=0)throw"rate must be greater than 0";if(e<1)throw"size must be at least 1"}static parse(t){let s=/(?<rate>\d+)\s*\/\s*(?<unit>second|minute|hour|day|week)\s*(,\s*(?<size>\d+))?/gi.exec(t);if(!s)throw"unable to parse refill value "+t;let n=parseInt(s.groups.rate),r=i.unitToDenominator(s.groups.unit.toLowerCase()),o=parseInt(s.groups.size??"1");return new i(n/r,o)}static unitToDenominator(t){switch(t){case"second":return 1;case"minute":return 60;case"hour":return 3600;case"day":return 86400;case"week":return 604800;default:throw"unexpected unit"}}};var u=class{apply(t,e,s,n){let r=t.size-n,o=Math.floor(n),a=Math.max(e-n,0),c=a>0?Math.ceil(a/t.rate):0,h=`${t.size};w=${t.rate}`;return{allowed:s,limit:r,remaining:o,reset:c,policy:h}}};var g=class extends u{buckets=new Map;async consume(t,e,s=1){let n=Date.now(),r=this.buckets.get(t);r||(r={tokens:e.size,updated:n},this.buckets.set(t,r));let a=(n-r.updated)*e.rate/1e3;r.tokens=Math.min(e.size,r.tokens+a),r.updated=n;let c=r.tokens>=s;return c&&(r.tokens-=s),this.apply(e,s,c,r.tokens)}};import"redis";var k=class i extends u{constructor(e,s="bucket:",n="TokenBucket",r="consume"){super();this.redis=e;this.prefix=s;this.module=n;this.fname=r}async consume(e,s,n=1){let r=await this.redis.sendCommand(["TFCALL",`${this.module}.${this.fname}`,"0",this.prefix+e,s.size.toString(),s.rate.toString(),n.toString()]),o=!1,a=0;for(let c=0;c<r.length;c+=2){let h=r[c],f=r[c+1];switch(h){case"allowed":o=f===1;break;case"tokens":a=parseFloat(f);break}}return this.apply(s,n,o,a)}static async create(e,s="bucket:",n="TokenBucket",r="consume"){let o=`#!js name=${n} api_version=1.0
redis.registerFunction('${r}', (client, key, size, rate, count) => {
	const now = Date.now()

	let bucket = client.call('hgetall', key)
	if (bucket.updated) {
		const deltaMs = now - parseInt(bucket.updated)
		const deltaNo = deltaMs * rate / 1000

		bucket.tokens = Math.min(size, parseFloat(bucket.tokens) + deltaNo)
		bucket.updated = now
	} else {
		bucket = { tokens: size, updated: now }
	}

	const allowed = bucket.tokens >= count
	if (allowed) {
		bucket.tokens -= count
	}

	// calculate how many tokens, or fractions of a token, are needed for the bucket to be full
	const deltaNo = Math.max(size - bucket.tokens, 0)

	// calculate time until the bucket is full, based on refill rate
	const expire = deltaNo > 0 ? Math.ceil(deltaNo / rate) : 0

	client.call('hset', key, 'tokens', bucket.tokens.toString(), 'updated', bucket.updated.toString())
	client.call('expire', key, expire.toString())

	return {
		allowed,
		tokens: bucket.tokens,
	}
})`;return await e.sendCommand(["TFUNCTION","LOAD","REPLACE",o]),new i(e,s,n,r)}};var p=class{constructor(t,e){this.status=t,typeof e=="string"?this.body={message:e}:e?this.body=e:this.body={message:`Error: ${t}`}}toString(){return JSON.stringify(this.body)}};function l(i,t){throw(!!1||!1)&&(isNaN(i)||i<400||i>599)?new Error(`HTTP error status codes must be between 400 and 599 \u2014 ${i} is invalid`):new p(i,t)}var ot=new TextEncoder;var x=class{constructor(t,e,s){this.extractor=t;this.manager=e;this.bucket=s}handle=async t=>{let{event:e,resolve:s}=t,{locals:n}=e,r=await this.extractor.extract(e),o=await this.manager.validate(r);return n.api=new m(e,this.bucket,r,o),await s(e)}},m=class{constructor(t,e,s,n){this.event=t;this.bucket=e;this.key=s;this.info=n}_name="";_cost=1;_anon=!1;_has="";_any=[];_all=[];anonymous(){return this._anon=!0,this}name(t){return this._name=t,this}cost(t){return t<1&&l(500,"API cost must be at least 1"),this._cost=t,this}has(t){return this._has=t,this}any(t){return this._any=t,this}all(t){return this._all=t,this}async approve(t){let{key:e,info:s}=this;if(!this._anon&&!e&&l(401,"Missing API Key"),e&&!this.info&&l(403,"Invalid API Key"),s){if(s.expires&&s.expires.getTime()<Date.now()&&l(403,"API Key Expired"),this._has.length&&!s.permissions.includes(this._has)&&l(403,"Missing Permission: "+this._has),this._all.length&&!this._all.every(o=>s.permissions.includes(o))){let o=this._all.filter(a=>!s.permissions.includes(a)).join(", ");l(403,"Missing Permissions: "+o)}if(this._any.length&&!this._any.some(o=>s.permissions.includes(o))){let o=this._any.join(", ");l(403,"Missing any Permission: "+o)}}let n=(e||this.event.getClientAddress())+":"+this._name,r=await this.bucket.consume(n,t,this._cost);return this.event.setHeaders({"RateLimit-Limit":r.limit.toString(),"RateLimit-Remaining":r.remaining.toString(),"RateLimit-Reset":r.reset.toString(),"RateLimit-Policy":r.policy}),r.allowed||l(429,"Too Many Requests"),r}};var b=class{constructor(t){this.options=t}async extract(t){let e=null,s=t.request.clone();return this.options.cookie&&(e=t.cookies.get(this.options.cookie)??null),this.options.httpHeader&&(e=s.headers.get(this.options.httpHeader)||e),this.options.searchParam&&(e=t.url.searchParams.get(this.options.searchParam)||e),this.options.custom&&(e=await this.options.custom(t,e)),e}};import{randomBytes as P,createHash as S}from"crypto";import I from"base-x";import _ from"bad-words-next";import N from"bad-words-next/data/en.json";var C="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",d=I(C),H=new _({data:N}),w=class{constructor(t,e=32){this.storage=t;this.key_length=e}hashFromBytes(t){return S("sha256").update(t).digest("hex")}async generate(t){let e,s;do s=P(this.key_length),e=d.encode(s);while(H.check(e));let n=this.hashFromBytes(s);return await this.storage.put(n,t),e}async validate(t){if(!t)return null;let e=d.decode(t),s=this.hashFromBytes(e);return await this.storage.get(s)}async remove(t){let e=d.decode(t),s=this.hashFromBytes(e);return await this.storage.del(s)}async retrieve(t){return await this.storage.list(t)}},v=class{keys=new Map;async put(t,e){this.keys.set(t,e)}async get(t){return this.keys.get(t)??null}async del(t){this.keys.delete(t)}async list(t){return Array.from(this.keys.values()).filter(s=>s.user===t)}};export{m as Api,B as DAY,T as HOUR,x as Handler,v as InMemoryKeyStore,g as InMemoryTokenBucket,b as KeyExtractor,w as KeyManager,K as MINUTE,k as RedisTokenBucket,y as Refill,M as SECOND,u as TokenBucket,O as WEEK};
